rm(list=ls())

##Set working directory##
#getwd()
#setwd()

## read the area-species data from file
orig_data <- read.table("Regression_Data.txt", header=T)
attach(orig_data)

rep <- 5 # > 1
samp <- 10

c <- array(0,c(rep,3))
d <- array(0,c(rep,11))

par(mfrow=c(1,2))

## Linear regression on log-transformed variables ##

log_Area <- log(Area)
log_Nspecies <- log(Nspecies)
trans_model <- lm(log_Nspecies ~ log_Area)
summary(trans_model)

c[1,1:2] <- trans_model$coeff
c[1,3] <- as.numeric(summary(trans_model)[8])
plot(log_Area, log_Nspecies)
abline(lm(log_Nspecies ~ log_Area),lwd=2)

for (i in 2:rep){
Islands <- sample(Island,samp)
trans_model <- lm(log_Nspecies[Islands] ~ log_Area[Islands])
c[i,1:2] <- trans_model$coeff 
c[i,3] <- as.numeric(summary(trans_model)[8])
abline(lm(log_Nspecies[Islands] ~ log_Area[Islands]),col="red")}

## Regression with polynomial of log transformed data ##

log2 <- log_Area^2
log3 <- log_Area^3
log4 <- log_Area^4
log5 <- log_Area^5
log6 <- log_Area^6
log7 <- log_Area^7
log8 <- log_Area^8
log9 <- log_Area^9

pol_model <- lm(log_Nspecies ~ log_Area+log2+log3+log4+log5+log6+log7+log8+log9)
summary(pol_model)

d[1,1:10] <- pol_model$coeff
d[1,11] <- as.numeric(summary(pol_model)[8])
plot(log_Area, log_Nspecies)
fit <- fitted(pol_model)
lines(log_Area,fit,lwd=2)

for (i in 2:rep){
Islands <- sample(Island,samp)
pol_model <- lm(log_Nspecies[Islands] ~log_Area[Islands]+log2[Islands]+log3[Islands]+
                                       log4[Islands]+log5[Islands]+log6[Islands]+log7[Islands]+
                                       log8[Islands]+log9[Islands])
d[i,1:10] <- pol_model$coeff
d[i,11] <- as.numeric(summary(pol_model)[8])
fit <- fitted(pol_model)
lines(log_Area[Islands],fit,col="red")
}

colnames(c) <- c("b1","b2","r2")
c

colnames(d) <- c("b1","b2","b3","b4","b5","b6","b7","b8","b9","b10","r2")
d

detach(orig_data)
